'''
exttester.axon_modbus_client
    Created on 15 Jun 2018
@author: Tom Knot <knot@faster.cz>
'''

from pymodbus.client.sync import ModbusTcpClient as ModbusClient

class UniPiModbusClient(object):
    client = None
    connected = False

    def __init__(self):
        self.client = ModbusClient('localhost', port=502)
    
    def reconnect(self):
        try:
            self.client.close()
        except BaseException, E:
            print "Exc: " + str(E)
        self.client.connect()
        self.connected = True
        
    def read_coil(self, address):
        resp = None
        try:
            if not self.connected:
                self.reconnect()
            resp = self.client.read_coils(address)
        except BaseException, E:
            print "Exc: " + str(E)
            self.connected = False
        return resp
        
    def write_coil(self, address, value):
        resp = None
        try:
            if not self.connected:
                self.reconnect()
            resp = self.client.write_coil(address, value)
        except BaseException, E:
            print "Exc: " + str(E)
            self.connected = False
        return resp
        
    def read_register(self, address):
        resp = None
        try:
            if not self.connected:
                self.reconnect()
            resp = self.client.read_holding_registers(address)
            resp = resp.registers[0]
        except BaseException, E:
            print "Exc: " + str(E)
            self.connected = False
        return resp
        
    def write_register(self, address, value):
        resp = None
        try:
            if not self.connected:
                self.reconnect()
            print "UMC-WR: %s %s" % (str(address), str(value))
            resp = self.client.write_register(address, value)
        except BaseException, E:
            print "Exc: " + str(E)
            self.connected = False
        return resp
    